Index: /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.cs	(revision 3455)
@@ -95,5 +95,4 @@
         executionTimeTextBox.Enabled = false;
       } else {
-        logView.ReadOnly = ReadOnly;
         logView.Enabled = true;
         executionTimeTextBox.Enabled = true;
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 3455)
@@ -125,5 +125,4 @@
         itemsListView.Enabled = true;
         detailsGroupBox.Enabled = true;
-        viewHost.ReadOnly = ReadOnly;
       }
     }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 3455)
@@ -100,5 +100,4 @@
         itemsListView.Enabled = true;
         detailsGroupBox.Enabled = true;
-        viewHost.ReadOnly = ReadOnly;
       }
     }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 3455)
@@ -128,5 +128,4 @@
         itemsListView.Enabled = true;
         detailsGroupBox.Enabled = true;
-        viewHost.ReadOnly = ReadOnly;
       }
     }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/OperatorGraphView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/OperatorGraphView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/OperatorGraphView.cs	(revision 3455)
@@ -105,6 +105,4 @@
       operatorsView.Enabled = Content != null;
       operatorTreeView.Enabled = Content != null;
-      operatorsView.ReadOnly = ReadOnly;
-      operatorTreeView.ReadOnly = ReadOnly;
       operatorsContextMenuStrip.Enabled = Content != null && !ReadOnly;
     }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ParameterizedNamedItemView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ParameterizedNamedItemView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ParameterizedNamedItemView.cs	(revision 3455)
@@ -63,5 +63,4 @@
     private void SetEnabledStateOfControls() {
       parameterCollectionView.Enabled = Content != null;
-      parameterCollectionView.ReadOnly = ReadOnly;
     }
   }
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/ScopeView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/ScopeView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/ScopeView.cs	(revision 3455)
@@ -95,5 +95,4 @@
       scopesTreeView.Enabled = Content != null;
       variableCollectionView.Enabled = Content != null;
-      variableCollectionView.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariableValueView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariableValueView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariableValueView.cs	(revision 3455)
@@ -98,5 +98,4 @@
     private void SetEnabledStateOfControls() {
       valuePanel.Enabled = Content != null;
-      viewHost.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/VariableView.cs	(revision 3455)
@@ -105,5 +105,4 @@
       clearValueButton.Enabled = Content != null && Content.Value != null && !ReadOnly;
       valueGroupBox.Enabled = Content != null;
-      viewHost.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.cs	(revision 3455)
@@ -106,5 +106,4 @@
     private void SetEnabledStateOfControls() {
       parameterCollectionView.Enabled = Content != null;
-      parameterCollectionView.ReadOnly = ReadOnly;
       assembliesTreeView.Enabled = Content != null && !ReadOnly;
       namespacesTreeView.Enabled = Content != null && !ReadOnly;
Index: /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.cs	(revision 3455)
@@ -102,6 +102,4 @@
         screenshotButton.Enabled = true;
         detailsViewHost.Enabled = true;
-        detailsViewHost.ReadOnly = ReadOnly;
-        graphVisualizationInfoView.ReadOnly = ReadOnly;
         connectButton.Enabled = !ReadOnly;
       }
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/AlgorithmOperatorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/AlgorithmOperatorView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/AlgorithmOperatorView.cs	(revision 3455)
@@ -94,7 +94,5 @@
       breakpointCheckBox.Enabled = Content != null && !ReadOnly;
       parameterCollectionView.Enabled = Content != null;
-      parameterCollectionView.ReadOnly = ReadOnly;
       operatorGraphViewHost.Enabled = Content != null;
-      operatorGraphViewHost.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/MultiOperatorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/MultiOperatorView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/MultiOperatorView.cs	(revision 3455)
@@ -93,7 +93,5 @@
       breakpointCheckBox.Enabled = Content != null && !ReadOnly;
       operatorListView.Enabled = Content != null;
-      operatorListView.ReadOnly = ReadOnly;
       parameterCollectionView.Enabled = Content != null;
-      parameterCollectionView.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Operators.Views/3.3/ValuesCollectorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators.Views/3.3/ValuesCollectorView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Operators.Views/3.3/ValuesCollectorView.cs	(revision 3455)
@@ -93,7 +93,5 @@
       breakpointCheckBox.Enabled = Content != null && !ReadOnly;
       collectedValuesView.Enabled = Content != null;
-      collectedValuesView.ReadOnly = ReadOnly;
       parameterCollectionView.Enabled = Content != null;
-      parameterCollectionView.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.cs	(revision 3455)
@@ -115,13 +115,9 @@
     private void SetEnableStateOfControls() {
       parameterCollectionView.Enabled = Content != null;
-      parameterCollectionView.ReadOnly = ReadOnly;
       newProblemButton.Enabled = Content != null && !ReadOnly;
       openProblemButton.Enabled = Content != null && !ReadOnly;
       problemViewHost.Enabled = Content != null;
-      problemViewHost.ReadOnly = ReadOnly;
       resultsView.Enabled = Content != null;
-      resultsView.ReadOnly = ReadOnly;
       runsView.Enabled = Content != null;
-      runsView.ReadOnly = ReadOnly;
       executionTimeTextBox.Enabled = Content != null;
       SetEnabledStateOfExecutableButtons();
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.cs	(revision 3455)
@@ -99,7 +99,5 @@
       openAlgorithmButton.Enabled = Content != null && !ReadOnly;
       algorithmViewHost.Enabled = Content != null;
-      algorithmViewHost.ReadOnly = ReadOnly;
       runsView.Enabled = Content != null;
-      runsView.ReadOnly = ReadOnly;
       executionTimeTextBox.Enabled = Content != null;
       SetEnabledStateOfExecutableButtons();
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs	(revision 3455)
@@ -112,5 +112,4 @@
     private void SetEnableStateOfControls() {
       engineViewHost.Enabled = Content != null;
-      engineViewHost.ReadOnly = ReadOnly;
       newOperatorGraphButton.Enabled = false;
       openOperatorGraphButton.Enabled = false;
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/ExperimentView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/ExperimentView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/ExperimentView.cs	(revision 3455)
@@ -87,7 +87,5 @@
     private void SetEnableStateOfControls() {
       optimizerListView.Enabled = Content != null;
-      optimizerListView.ReadOnly = ReadOnly;
       runsViewHost.Enabled = Content != null;
-      runsViewHost.ReadOnly = ReadOnly;
       executionTimeTextBox.Enabled = Content != null;
       SetEnabledStateOfExecutableButtons();
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/ResultView.cs	(revision 3455)
@@ -106,5 +106,4 @@
       dataTypeTextBox.Enabled = Content != null;
       viewHost.Enabled = Content != null;
-      viewHost.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 3455)
@@ -119,5 +119,4 @@
         removeButton.Enabled = itemsListView.SelectedItems.Count > 0 && !Content.IsReadOnly && !ReadOnly;
         viewHost.Enabled = true;
-        viewHost.ReadOnly = ReadOnly;
       }
     }
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 3455)
@@ -89,5 +89,4 @@
       listView.Enabled = Content != null;
       viewHost.Enabled = Content != null;
-      viewHost.ReadOnly = ReadOnly;
       showAlgorithmButton.Enabled = Content != null && !Locked;
     }
Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.cs	(revision 3455)
@@ -70,8 +70,6 @@
     private void SetEnableStateOfControls() {
       globalScopeView.Enabled = Content != null;
-      globalScopeView.ReadOnly = ReadOnly;
       newOperatorGraphButton.Enabled = Content != null && !ReadOnly;
       openOperatorGraphButton.Enabled = Content != null && !ReadOnly;
-      operatorGraphViewHost.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Parameters.Views/3.3/ConstrainedValueParameterView.cs	(revision 3455)
@@ -113,5 +113,4 @@
       valueGroupBox.Enabled = Content != null;
       valueComboBox.Enabled = (valueComboBox.Items.Count > 0) && !ReadOnly;
-      viewHost.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Parameters.Views/3.3/ValueLookupParameterView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters.Views/3.3/ValueLookupParameterView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Parameters.Views/3.3/ValueLookupParameterView.cs	(revision 3455)
@@ -110,5 +110,4 @@
       clearValueButton.Enabled = Content != null && Content.Value != null && !ReadOnly;
       valueGroupBox.Enabled = Content != null;
-      viewHost.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Parameters.Views/3.3/ValueParameterView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters.Views/3.3/ValueParameterView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Parameters.Views/3.3/ValueParameterView.cs	(revision 3455)
@@ -107,5 +107,4 @@
       clearValueButton.Enabled = Content != null && Content.Value != null && !ReadOnly;
       valueGroupBox.Enabled = Content != null;
-      viewHost.ReadOnly = ReadOnly;
     }
 
Index: /trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/TravelingSalesmanProblemView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/TravelingSalesmanProblemView.cs	(revision 3454)
+++ /trunk/sources/HeuristicLab.Problems.TravelingSalesman.Views/3.3/TravelingSalesmanProblemView.cs	(revision 3455)
@@ -86,7 +86,5 @@
     private void SetEnabledStateOfControls() {
       parameterCollectionView.Enabled = Content != null;
-      parameterCollectionView.ReadOnly = ReadOnly;
       pathTSPTourView.Enabled = Content != null;
-      pathTSPTourView.ReadOnly = ReadOnly;
       importButton.Enabled = Content != null && !ReadOnly;
     }