Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.cs	(revision 3442)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.cs	(revision 3461)
@@ -44,19 +44,11 @@
     public new SymbolicRegressionSolution Content {
       get { return (SymbolicRegressionSolution)base.Content; }
-      set {
-        base.Content = value;
-      }
+      set {        base.Content = value;       }
     }
 
-    private ViewHost viewHost;
 
     public SimplifiedSymbolicExpressionModelView()
       : base() {
       InitializeComponent();
-
-      // manual initialization of viewhost for the simplified model
-      viewHost = new ViewHost();
-      viewHost.Dock = DockStyle.Fill;
-      simplifiedModelGroupBox.Controls.Add(viewHost);
     }
 
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.designer.cs	(revision 3442)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.designer.cs	(revision 3461)
@@ -46,8 +46,11 @@
     private void InitializeComponent() {
       this.simplifiedModelGroupBox = new System.Windows.Forms.GroupBox();
+      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.simplifiedModelGroupBox.SuspendLayout();
       this.SuspendLayout();
       // 
       // simplifiedModelGroupBox
       // 
+      this.simplifiedModelGroupBox.Controls.Add(this.viewHost);
       this.simplifiedModelGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
       this.simplifiedModelGroupBox.Location = new System.Drawing.Point(0, 0);
@@ -57,4 +60,16 @@
       this.simplifiedModelGroupBox.TabStop = false;
       this.simplifiedModelGroupBox.Text = "Simplified Symbolic Expression Model";
+      // 
+      // viewHost
+      // 
+      this.viewHost.Caption = null;
+      this.viewHost.Content = null;
+      this.viewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.viewHost.Location = new System.Drawing.Point(3, 16);
+      this.viewHost.Name = "viewHost";
+      this.viewHost.ReadOnly = false;
+      this.viewHost.Size = new System.Drawing.Size(346, 394);
+      this.viewHost.TabIndex = 0;
+      this.viewHost.ViewType = null;
       // 
       // SimplifiedSymbolicExpressionModelView
@@ -66,4 +81,5 @@
       this.Name = "SimplifiedSymbolicExpressionModelView";
       this.Size = new System.Drawing.Size(352, 413);
+      this.simplifiedModelGroupBox.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -73,4 +89,5 @@
 
     private System.Windows.Forms.GroupBox simplifiedModelGroupBox;
+    private HeuristicLab.MainForm.WindowsForms.ViewHost viewHost;
 
   }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.cs	(revision 3442)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.cs	(revision 3461)
@@ -44,19 +44,10 @@
     public new SymbolicRegressionSolution Content {
       get { return (SymbolicRegressionSolution)base.Content; }
-      set {
-        base.Content = value;
-      }
+      set { base.Content = value; }
     }
-
-    private ViewHost viewHost;
 
     public SymbolicExpressionModelView()
       : base() {
       InitializeComponent();
-
-      // manual initialization of viewhost for the simplified model
-      viewHost = new ViewHost();
-      viewHost.Dock = DockStyle.Fill;
-      modelGroupBox.Controls.Add(viewHost);
     }
 
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.designer.cs	(revision 3442)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.designer.cs	(revision 3461)
@@ -46,8 +46,11 @@
     private void InitializeComponent() {
       this.modelGroupBox = new System.Windows.Forms.GroupBox();
+      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.modelGroupBox.SuspendLayout();
       this.SuspendLayout();
       // 
       // modelGroupBox
       // 
+      this.modelGroupBox.Controls.Add(this.viewHost);
       this.modelGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
       this.modelGroupBox.Location = new System.Drawing.Point(0, 0);
@@ -57,4 +60,16 @@
       this.modelGroupBox.TabStop = false;
       this.modelGroupBox.Text = "Symbolic Expression Model";
+      // 
+      // viewHost
+      // 
+      this.viewHost.Caption = null;
+      this.viewHost.Content = null;
+      this.viewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.viewHost.Location = new System.Drawing.Point(3, 16);
+      this.viewHost.Name = "viewHost";
+      this.viewHost.ReadOnly = false;
+      this.viewHost.Size = new System.Drawing.Size(346, 394);
+      this.viewHost.TabIndex = 0;
+      this.viewHost.ViewType = null;
       // 
       // SymbolicExpressionModelView
@@ -66,4 +81,5 @@
       this.Name = "SymbolicExpressionModelView";
       this.Size = new System.Drawing.Size(352, 413);
+      this.modelGroupBox.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -73,4 +89,5 @@
 
     private System.Windows.Forms.GroupBox modelGroupBox;
+    private HeuristicLab.MainForm.WindowsForms.ViewHost viewHost;
 
   }