Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.Designer.cs	(revision 3481)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.Designer.cs	(revision 3482)
@@ -53,7 +53,7 @@
       this.yJitterLabel.Location = new System.Drawing.Point(257, 6);
       this.yJitterLabel.Name = "yJitterLabel";
-      this.yJitterLabel.Size = new System.Drawing.Size(29, 13);
+      this.yJitterLabel.Size = new System.Drawing.Size(32, 13);
       this.yJitterLabel.TabIndex = 13;
-      this.yJitterLabel.Text = "jitter:";
+      this.yJitterLabel.Text = "Jitter:";
       // 
       // xJitterlabel
@@ -61,14 +61,14 @@
       this.xJitterlabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.xJitterlabel.AutoSize = true;
-      this.xJitterlabel.Location = new System.Drawing.Point(461, 309);
+      this.xJitterlabel.Location = new System.Drawing.Point(460, 308);
       this.xJitterlabel.Name = "xJitterlabel";
-      this.xJitterlabel.Size = new System.Drawing.Size(29, 13);
+      this.xJitterlabel.Size = new System.Drawing.Size(32, 13);
       this.xJitterlabel.TabIndex = 12;
-      this.xJitterlabel.Text = "jitter:";
+      this.xJitterlabel.Text = "Jitter:";
       // 
       // xTrackBar
       // 
       this.xTrackBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.xTrackBar.Location = new System.Drawing.Point(496, 306);
+      this.xTrackBar.Location = new System.Drawing.Point(498, 305);
       this.xTrackBar.Maximum = 100;
       this.xTrackBar.Name = "xTrackBar";
@@ -82,5 +82,5 @@
       this.xAxisLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.xAxisLabel.AutoSize = true;
-      this.xAxisLabel.Location = new System.Drawing.Point(213, 309);
+      this.xAxisLabel.Location = new System.Drawing.Point(211, 307);
       this.xAxisLabel.Name = "xAxisLabel";
       this.xAxisLabel.Size = new System.Drawing.Size(15, 13);
@@ -94,5 +94,5 @@
       this.xAxisComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.xAxisComboBox.FormattingEnabled = true;
-      this.xAxisComboBox.Location = new System.Drawing.Point(234, 307);
+      this.xAxisComboBox.Location = new System.Drawing.Point(232, 305);
       this.xAxisComboBox.Name = "xAxisComboBox";
       this.xAxisComboBox.Size = new System.Drawing.Size(221, 21);
@@ -122,5 +122,5 @@
       // yTrackBar
       // 
-      this.yTrackBar.Location = new System.Drawing.Point(292, 3);
+      this.yTrackBar.Location = new System.Drawing.Point(295, 3);
       this.yTrackBar.Maximum = 100;
       this.yTrackBar.Name = "yTrackBar";
@@ -146,9 +146,9 @@
       this.sizeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.sizeLabel.AutoSize = true;
-      this.sizeLabel.Location = new System.Drawing.Point(371, 6);
+      this.sizeLabel.Location = new System.Drawing.Point(369, 6);
       this.sizeLabel.Name = "sizeLabel";
-      this.sizeLabel.Size = new System.Drawing.Size(64, 13);
+      this.sizeLabel.Size = new System.Drawing.Size(66, 13);
       this.sizeLabel.TabIndex = 15;
-      this.sizeLabel.Text = "Bubble size:";
+      this.sizeLabel.Text = "Bubble Size:";
       // 
       // chart
@@ -169,5 +169,5 @@
       series2.YValuesPerPoint = 2;
       this.chart.Series.Add(series2);
-      this.chart.Size = new System.Drawing.Size(556, 263);
+      this.chart.Size = new System.Drawing.Size(554, 261);
       this.chart.TabIndex = 16;
       this.chart.Text = "chart1";
@@ -206,5 +206,5 @@
       this.radioButtonGroup.Controls.Add(this.zoomButton);
       this.radioButtonGroup.Controls.Add(this.selectButton);
-      this.radioButtonGroup.Location = new System.Drawing.Point(6, 299);
+      this.radioButtonGroup.Location = new System.Drawing.Point(3, 297);
       this.radioButtonGroup.Name = "radioButtonGroup";
       this.radioButtonGroup.Size = new System.Drawing.Size(135, 32);
@@ -217,7 +217,7 @@
       this.colorButton.Enabled = false;
       this.colorButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
-      this.colorButton.Location = new System.Drawing.Point(144, 306);
+      this.colorButton.Location = new System.Drawing.Point(144, 305);
       this.colorButton.Name = "colorButton";
-      this.colorButton.Size = new System.Drawing.Size(64, 23);
+      this.colorButton.Size = new System.Drawing.Size(64, 21);
       this.colorButton.TabIndex = 20;
       this.colorButton.Text = "Color";
@@ -234,4 +234,6 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.BackColor = System.Drawing.SystemColors.Window;
+      this.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
       this.Controls.Add(this.colorButton);
       this.Controls.Add(this.radioButtonGroup);
@@ -248,5 +250,5 @@
       this.Controls.Add(this.yTrackBar);
       this.Name = "RunCollectionBubbleChartView";
-      this.Size = new System.Drawing.Size(567, 334);
+      this.Size = new System.Drawing.Size(565, 332);
       ((System.ComponentModel.ISupportInitialize)(this.xTrackBar)).EndInit();
       ((System.ComponentModel.ISupportInitialize)(this.yTrackBar)).EndInit();
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs	(revision 3481)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.cs	(revision 3482)
@@ -63,4 +63,8 @@
       this.chart.Series[0]["BubbleMaxScale"] = "Auto";
       this.chart.Series[0]["BubbleMinScale"] = "Auto";
+      this.chart.Series[0].SmartLabelStyle.Enabled = true;
+      this.chart.Series[0].SmartLabelStyle.IsMarkerOverlappingAllowed = false;
+      this.chart.Series[0].SmartLabelStyle.IsOverlappedHidden = true;
+
       this.chart.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
       this.chart.ChartAreas[0].CursorY.IsUserSelectionEnabled = true;
@@ -69,4 +73,5 @@
       this.chart.ChartAreas[0].CursorX.Interval = 0;
       this.chart.ChartAreas[0].CursorY.Interval = 0;
+
     }
 
@@ -186,5 +191,4 @@
         if (run.Visible) {
           DataPoint point = new DataPoint(xValue.Value, new double[] { yValue.Value, sizeValue.Value });
-          point.ToolTip = this.CreateTooltip(row);
           point.Tag = run;
           point.Color = run.Color;